<script context="module">
	export const prerender = true;
</script>

<script>
	import AutoComplete from 'simple-svelte-autocomplete';
	import stationList from '/static/stationList.json';
	import { goto } from '$app/navigation';
	import { onMount } from 'svelte';
	import { stationHistory } from '$lib/preferences';

	let enableGeolocation = true;
	let selectedItem;
	const selectStation = () => {
		if (typeof selectedItem === 'undefined') return;

		stationHistory.add(selectedItem);
		goto(`/station/${selectedItem.name}/${selectedItem.id}`);
	};

	const getClosestStation = (position) => {
		let distances = [];

		for (const station of stationList) {
			distances.push(Math.sqrt(
				(position.coords.latitude - station.latitude) ** 2
				+ (position.coords.longitude - station.longitude) ** 2
			));
		}

		selectedItem = stationList[distances.indexOf(Math.min(...distances))];
	};

	const getPosition = () => {
		navigator.geolocation.getCurrentPosition(getClosestStation, () => {
			console.error('Unable to retrieve your location');
		});
	};

	onMount(() => {
		enableGeolocation = navigator.geolocation;
	});
</script>

<svelte:head>
	<title>Mon Infoclimat.fr</title>
</svelte:head>

<section>
	<h1>
		<div class="welcome">
			<picture>
				<source srcset="/logo.webp" type="image/webp" />
				<img src="/logo.png" alt="Mon Infoclimat" />
			</picture>
		</div>
	</h1>

	<div class='station-selection'>
		<AutoComplete
			items={stationList}
			labelFieldName="name"
			valueFieldName="id"
			maxItemsToShowInList="3"
			bind:selectedItem
			value={selectedItem}
			onChange={selectStation}
			hideArrow
		/>

		{#if enableGeolocation}
			<button
				on:click={getPosition}
			>
				Me localiser
			</button>
		{/if}
	</div>

	<a href='/carte' sveltekit:prefetch>Voir la carte</a>

</section>

{#if Object.keys($stationHistory).length > 0}
	<section>
		<h2>Consulté récemment</h2>
		<ul>
			{#each Object.values($stationHistory) as station}
				<li><a href='/station/{station.name}/{station.id}'>{station.name}</a></li>
			{/each}
		</ul>
	</section>
{/if}

<style>
	section {
		display: flex;
		flex-direction: column;
		justify-content: center;
		align-items: center;
		flex: 1;
	}

	h1 {
		width: 100%;
	}

	h2 {
			margin-bottom: 0;
			font-weight: bold;
	}

	ul {
			list-style: none;
      padding: 0;
      display: flex;
			flex-wrap: wrap;
			justify-content: center;
	}

	li {
			margin: 0 10px;
	}

  .station-selection {
			@apply items-center;
			min-width: 90%;
			justify-content: center;
  }

	button {
			@apply px-3 py-2 text-blue-900 bg-blue-100 hover:bg-blue-200 active:bg-blue-300 rounded-md mx-auto my-4 block;
	}

  :global(.autocomplete) {
			@apply m-auto;
      display: block!important;
			width: 70%;
  }

	:global(.autocomplete-input) {
      @apply rounded-md;
	}

  @screen sm {
			.station-selection {
          display: flex;
			}

      :global(.autocomplete) {
          @apply m-0;
      }

      :global(.autocomplete-input) {
          border-right: none;
      }

			button {
					@apply inline-block m-0;
			}
  }

	.welcome img {
			width: 100%;
			max-width: 720px;
			margin: 40px auto;
	}

	a {
			@apply text-blue-500;
			margin: 40px auto;
	}
</style>
